/****************************************************************************
**
**  Copyright (c) 1982-1997 Pervasive Software Inc. All Rights Reserved.
**
****************************************************************************/
/****************************************************************************
**
** FIXPARMS.H
**	  This module contains definitions used by fixparms.c.
**
****************************************************************************/
#if !defined(_FIXPARMS_H)
#define _FIXPARMS_H

#if !defined(NULL)
#define NULL 0
#endif /* NULL */

#if !defined(FALSE)
#define FALSE 0
#endif /* FALSE */

#if !defined(TRUE)
#define TRUE 1
#endif /* TRUE */

#define FXP_DEFAULT     0
#define FXP_COPYUP      1
#define FXP_COPYDOWN    2
#define FXP_FREE        3
#define FXP_OFFPTR      4
#define FXP_PTROFF      5


#define SEND_DATA     0x0001      /* value is sent to server               */
#define RET_DATA      0x0002      /* value is returned to application      */
#define CONST_VAL     0x0004      /* constant integer value                */
#define LONG_VAL      0x0008      /* long integer value                    */
#define STR_PARM      0x0010      /* null terminated string                */
#define DATA_PARM     0x0020      /* data, ASCII or binary                 */
#define LEN_VAL       0x0040      /* parameter is a buffer length          */
#define CNT_VAL       0x0080      /* parameter is a count value            */
#define SPEC_PARM     0x0100      /* parameter requires special processing */
#define REDIR_DEVICE  0x0200      /* which server to access                */


#define C1          0x0001
#define C4          0x0004
#define C8          0x0008
#define C10         0x000A
#define C20         0x0014
#define C22         0x0016
#define C28         0x001C
#define C30         0x001E
#define C44         0x002C
#define C46         0x002E
#define C64         0x0040
#define CVAR        0       /* indicates variable length, use buffer length */


/* offsets of items of interest in an SSQL parmblock  */
#define  PARM_ID    0           /* XQL identifier  */
#define  PARM_FCN   4           /* function code   */
#define  PARM_HNDL  6           /* file identifier */
#define  PARM_CURSR 6           /* cursor identifier */
#define  PARM_STAT  8           /* return status */
#define  PARM_SSID 10           /* session identifier */
#define  PARM_USID 10           /* user identifier */
#define  VAR_DATA  12           /* start of variable data */
#define  PARM_FIXED_LEN 12      /* start of variable data */


extern BTI_WORD FcnParmCount[];
extern BTI_WORD FcnVariableLen[];
extern BTI_WORD initParmOffsets;
extern BTI_WORD ParmOffsets[];
extern BTI_BYTE parmLength[];
extern BTI_WORD parmFlags[];

extern BTI_SINT fixParms(
                   PARMBLOCK *from,
                   PARMBLOCK *to );

extern BTI_SINT unfixParms(
                   PARMBLOCK *from,
                   PARMBLOCK *to );

#endif /* !_FIXPARMS_H */
