{*************************************************************************
**
**  Copyright 1998 Pervasive Software Inc. All Rights Reserved
**
*************************************************************************}
{***********************************************************************
	 SQLAPI16.PAS
			This is the Pascal unit for Scalable SQL to be called by a Borland
			Pascal or Delphi applications on 16-bit Windows.

************************************************************************}
UNIT sqlapi16;

INTERFACE
{***********************************************************************
	 The following types are needed for use with 'XQLCallback'.
************************************************************************}
TYPE
	 SQL_YIELD_T = RECORD
			iSessionID : WORD;
	 END;

	 BTRV_YIELD_T = RECORD
			iOpCode           : WORD;
			bClientIDlastFour : ARRAY[ 1..4 ] OF BYTE;
	 END;

	 BTI_CB_INFO_T = RECORD
			typex : WORD;
			size  : WORD;
			case u: Boolean of
				 False: ( sYield : SQL_YIELD_T );
				 True:  ( bYield : BTRV_YIELD_T );
	 END;

	 BTI_CB_FUNC_PTR_T = FUNCTION(
													VAR bCallbackInfo : BTI_CB_INFO_T;
													VAR bUserData )   : WORD;

	 BTI_CB_FUNC_PTR_PTR_T = ^BTI_CB_FUNC_PTR_T;
{***********************************************************************
	 SESSION MANAGEMENT PRIMITIVES
			The following primitives are required by applications which
			want to use multiple SQL logins:
				 xGetSessionID
				 xPutSessionID
************************************************************************}
	 FUNCTION xGetSessionID(
							 VAR iSessionID : INTEGER ) : INTEGER;

	 FUNCTION xPutSessionID(
							 iSessionID : INTEGER ) : INTEGER;

{***********************************************************************
	 MISCELLANEOUS FUNCTIONS
			XQLCallback                    ( MS Windows )
			xShareSessionID                ( MS Windows )
			SQLGetCountDatabaseNames       ( MS Windows )
			SQLGetCountRemoteDatabaseNames ( MS Windows )
			SQLGetDatabaseNames            ( MS Windows )
			SQLGetRemoteDatabaseNames      ( MS Windows )
			SQLUnloadDBNames               ( MS Windows )
************************************************************************}
	 FUNCTION XQLCallback(
							 iAction                   : WORD;
							 iOption                   : WORD;
							 fCallBackFunction         : BTI_CB_FUNC_PTR_T;
							 fPreviousCallBackFunction : BTI_CB_FUNC_PTR_PTR_T;
					 VAR bUserData;
					 VAR bPreviousUserData         : POINTER ) : INTEGER;

	 FUNCTION xShareSessionID(
							 VAR tChangeCount : INTEGER ) : INTEGER;

	 FUNCTION SQLGetCountDatabaseNames(
							VAR tCount : INTEGER ) : INTEGER;

	 FUNCTION SQLGetCountRemoteDatabaseNames(
							VAR tCount : INTEGER ) : INTEGER;

	 FUNCTION SQLGetDatabaseNames(
							VAR tBufLen  : INTEGER;
                     VAR bDataBuf ) : INTEGER;

	 FUNCTION SQLGetRemoteDatabaseNames(
							VAR tBufLen  : INTEGER;
                     VAR bDataBuf  ) : INTEGER;

	 FUNCTION SQLUnloadDBNAMES(
							iReserved : INTEGER ) : INTEGER;

{***********************************************************************
	 SQL-LEVEL FUNCTIONS
			XQLCursor     XQLFetch    XQLSPUtility   XQLVersion
			XQLCompile    XQLFormat   XQLStatus      XQLConvert
      XQLDescribe   XQLFree     XQLStop        XQLValidate
      XQLExec       XQLLogin    XQLSubst       XQLMask
                    XQLLogout
***********************************************************************}
   FUNCTION XQLCursor(
               VAR iCursorID : INTEGER ) : INTEGER;

   FUNCTION XQLCompile(
               iCursorID     : INTEGER;
           VAR tStatementLen : INTEGER;
           VAR sStatement )  : INTEGER;

   FUNCTION XQLDescribe(
               iCursorID   : INTEGER;
               tPosition   : INTEGER;
           VAR iDataType   : INTEGER;
           VAR tSize       : INTEGER;
           VAR tDecPlaces  : INTEGER;
           VAR tDisplayLen : INTEGER;
           VAR tNameLen    : INTEGER;
           VAR sName     ) : INTEGER;

    FUNCTION XQLExec(
                iCursorID : INTEGER ) : INTEGER;

   FUNCTION XQLFetch(
               iCursorID  : INTEGER;
               iOption    : INTEGER;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf;
           VAR lCount     : LONGINT;
               iASCIIFlag : INTEGER;
							 iSpacing   : INTEGER ) : INTEGER;

   FUNCTION XQLFormat(
               iCursorID : INTEGER;
               tPosition : INTEGER;
               tMaskLen  : INTEGER;
           VAR sMask   ) : INTEGER;

   FUNCTION XQLFree(
               iCursorID : INTEGER ) : INTEGER;

   FUNCTION XQLLogin(
               VAR sUser;
               VAR sPassword;
               VAR sDDPath;
               VAR sDataPath;
               VAR sReserved;
                   iFeaturesUsed : INTEGER ) : INTEGER;

   FUNCTION XQLLogout : INTEGER;

   FUNCTION XQLSPUtility(
               iCursorID       : INTEGER;
               iOption         : INTEGER;
           VAR tStatementCount : INTEGER;
           VAR tStatementExec  : INTEGER;
           VAR tBufLen         : INTEGER;
           VAR bDataBuf )      : INTEGER;

   FUNCTION XQLStatus(
               iCursor : INTEGER;
               iOption : INTEGER;
           VAR sStatBuf ) : INTEGER;

   FUNCTION XQLStop : INTEGER;

   FUNCTION XQLSubst(
               iCursorID : INTEGER;
               tCount    : INTEGER;
               tNameLen  : INTEGER;
           VAR sVarNames;
               tTextLen  : INTEGER;
           VAR sValueText ) : INTEGER;

   FUNCTION XQLVersion(
               VAR sVersion ) : INTEGER;

   FUNCTION XQLConvert(
               iOption  : INTEGER;
               iType    : INTEGER;
               tSize    : INTEGER;
               tDec     : INTEGER;
               tdSize   : INTEGER;
           VAR sValue;
           VAR sRetVal;
           VAR sMask;
               sJustify : INTEGER ) : INTEGER;

   FUNCTION XQLValidate(
               VAR tCount     : INTEGER;
               VAR sFieldName;
                   tBufLen    : INTEGER;
               VAR bDataBuf ) : INTEGER;

   FUNCTION XQLMask(
               iOption : INTEGER;
							 iType   : INTEGER;
               tSize   : INTEGER;
               tDec    : INTEGER;
           VAR tLen    : INTEGER;
           VAR sMask ) : INTEGER;

{***********************************************************************
   HISTORICAL RELATIONAL PRIMITIVES
      The following functions will be phased out over time.  They
      are included here to support existing applications.  New applications
      should not use these functions.

      xCompute    xOrder         xDD            xAccess
      xDescribe   xRemall        xDDAttr        xPassword
      xMovefld    xRemove        xDDModify      xSecurity
      xFetch      xReset         xDDCreate      xUser
      xField      xRestrict      xDDDrop        xChar
      xFree       xStop          xDDField       xVersion
      xInsert     xTrans         xDDFile        xStatus
      xJoin       xStore         xDDIndex       xConvert
      xLogin      xRecall        xDDPath        xValidate
      xLogout     xUpdate        xDDView        xMask
      xNew        xUpdall
***********************************************************************}
   FUNCTION xCompute(
               iCursorID  : INTEGER;
           VAR sFldName;
               iFldType   : INTEGER;
               tFldLen    : INTEGER;
               tDecPlaces : INTEGER;
           VAR tExpLen    : INTEGER;
           VAR sExpression ) : INTEGER;

	 FUNCTION xDescribe(
               iCursorID  : INTEGER;
               iOption    : INTEGER;
           VAR tBufLen    : INTEGER;
               tPosition  : INTEGER;
           VAR tCount     : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xMovefld(
               iCursorID     : INTEGER;
               tFromPosition : INTEGER;
               tToPosition   : INTEGER ) : INTEGER;

   FUNCTION xFetch(
               iCursorID    : INTEGER;
           VAR tBufLen      : INTEGER;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
           VAR lRejectCount : LONGINT;
           VAR bDataBuf  )  : INTEGER;

   FUNCTION xField(
               iCursorID   : INTEGER;
               iOption     : INTEGER;
               tPosition   : INTEGER;
           VAR tCount      : INTEGER;
           VAR sFldNames ) : INTEGER;

   FUNCTION xFree(
               iCursorID : INTEGER ) : INTEGER;

   FUNCTION xInsert(
               iCursorID    : INTEGER;
					 VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT;
           VAR bDataBuf )   : INTEGER;

   FUNCTION xJoin(
               iCursorID    : INTEGER;
           VAR sSecFile;
           VAR sOwner;
               iOption      : INTEGER;
               tPriFldCount : INTEGER;
           VAR sPriFlds;
               tSecFldCount : INTEGER;
           VAR sSecFlds )   : INTEGER;

   FUNCTION xLogin(
           VAR sUser;
           VAR sPassword;
           VAR sDDPath;
           VAR sDataPath;
           VAR sReserved;
               iFeaturesUsed : INTEGER ) : INTEGER;

   FUNCTION xLogout : INTEGER;

   FUNCTION xNew(
           VAR iCursorID : INTEGER;
           VAR sFileName;
           VAR sOwner;
               iOpenMode : INTEGER ) : INTEGER;

   FUNCTION xOrder(
               iCursorID : INTEGER;
							 tCount    : INTEGER;
           VAR sOrder )  : INTEGER;

   FUNCTION xRemall(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
               lRejectCount : LONGINT ) : INTEGER;

   FUNCTION xRemove(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT ) : INTEGER;

   FUNCTION xReset(
           VAR sReserved ) : INTEGER;

   FUNCTION xRestrict(
               iCursorID : INTEGER;
               iOption   : INTEGER;
           VAR tExpLen   : INTEGER;
           VAR sExpression ) : INTEGER;

   FUNCTION xStop : INTEGER;

   FUNCTION xTrans(
               iOption : INTEGER ) : INTEGER;

   FUNCTION xStore(
               iCursorID : INTEGER;
					 VAR sViewName;
               tTextLen  : INTEGER;
           VAR sText )   : INTEGER;

   FUNCTION xRecall(
           VAR iCursorID   : INTEGER;
           VAR sViewName;
               tOwnerCount : INTEGER;
           VAR sOwner;
               iOpenMode   : INTEGER;
           VAR tTextLen    : INTEGER;
           VAR sText )     : INTEGER;

   FUNCTION xUpdate(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT;
           VAR bDataBuf )   : INTEGER;

   FUNCTION xUpdall(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
           VAR lRejectCount : LONGINT;
               tFldCount    : INTEGER;
           VAR sUpdateFld;
           VAR sReplaceFld ) : INTEGER;

   FUNCTION xDD(
           VAR sPathName;
							 iOption : INTEGER ) : INTEGER;

   FUNCTION xDDAttr(
                iOption    : INTEGER;
            VAR sFldName;
                iAttrType  : INTEGER;
            VAR tBufLen    : INTEGER;
            VAR sAttrBuf ) : INTEGER;

   FUNCTION xDDModify(
               iOption     : INTEGER;
           VAR sFileName;
               iCreate    : INTEGER;
           VAR sPathName;
           VAR sOwner;
               iOwnerFlag : INTEGER;
               tFldCount  : INTEGER;
           VAR bFldBuf;
               tIndxCount : INTEGER;
           VAR bIndxBuf ) : INTEGER;

   FUNCTION xDDCreate(
               iOption           : INTEGER;
           VAR sFileName;
               iCreate           : INTEGER;
           VAR sPathName;
           VAR sOwner;
               iOwnerFlag        : INTEGER;
               tFldCount         : INTEGER;
           VAR bFldBuf;
               tIndxCount        : INTEGER;
           VAR bIndxBuf;
               tBufLen           : INTEGER;
					 VAR bCreateParmsBuf ) : INTEGER;

   FUNCTION xDDDrop(
           VAR sName;
               iType   : INTEGER;
               iDelete : INTEGER ) : INTEGER;

    FUNCTION xDDField(
                iOption    : INTEGER;
            VAR tCount     : INTEGER;
            VAR sFldNames;
            VAR tBufLen    : INTEGER;
            VAR bDataBuf ) : INTEGER;

   FUNCTION xDDFile(
               iOption    : INTEGER;
           VAR tCount     : INTEGER;
           VAR sFileNames;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xDDIndex(
               iOption    : INTEGER;
           VAR tCount     : INTEGER;
           VAR sIndexName;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xDDPath(
               iOption     : INTEGER;
           VAR sPathName ) : INTEGER;

   FUNCTION xDDView(
					 VAR tCount     : INTEGER;
           VAR sViewName;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xAccess(
           VAR sMstrPswd;
           VAR sUser;
               iOption    : INTEGER;
               iAccRights : INTEGER;
           VAR sFileName;
           VAR tCount     : INTEGER;
           VAR sFldNames;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xPassword(
           VAR sUser;
           VAR sPassword ) : INTEGER;

   FUNCTION xSecurity(
           VAR sMstrPswd;
               iOption : INTEGER ) : INTEGER;

   FUNCTION xUser(
           VAR sMstPswd;
               iOption    : INTEGER;
           VAR sUser;
           VAR sPassword;
               iFlags     : INTEGER;
           VAR tCount     : INTEGER;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xChar(
               iOption : INTEGER;
               iType   : INTEGER;
           VAR cCharacter ) : INTEGER;

   FUNCTION xVersion(
           VAR sVersion ) : INTEGER;

   FUNCTION xStatus(
               iCursorID  : INTEGER;
               iOption    : INTEGER;
           VAR tLen       : INTEGER;
           VAR sStatBuf ) : INTEGER;

   FUNCTION xConvert(
               iOption  : INTEGER;
               iType    : INTEGER;
               tSize    : INTEGER;
               tDec     : INTEGER;
               tDSize   : INTEGER;
           VAR sValue;
           VAR sRetVal;
           VAR sMask;
               iJustify : INTEGER ) : INTEGER;

   FUNCTION xValidate(
           VAR tCount     : INTEGER;
           VAR sFieldName;
               tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;

   FUNCTION xMask(
							 iOption : INTEGER;
               iType   : INTEGER;
               tSize   : INTEGER;
               iDec    : INTEGER;
           VAR tLen    : INTEGER;
           VAR sMask ) : INTEGER;

{***********************************************************************
   PASCAL IMPLEMENTATION SECTION
************************************************************************}
IMPLEMENTATION

{***********************************************************************
   SESSION MANAGEMENT PRIMITIVES
************************************************************************}
   FUNCTION xGetSessionID(
               VAR iSessionID : INTEGER ) : INTEGER;
               external 'W1SQLV7' name 'XGETSESSIONID';

   FUNCTION xPutSessionID(
               iSessionID : INTEGER ) : INTEGER;
               external 'W1SQLV7' name 'XPUTSESSIONID';

{***********************************************************************
   MISCELLANEOUS FUNCTIONS
************************************************************************}
   FUNCTION XQLCallback(
               iAction                   : WORD;
               iOption                   : WORD;
               fCallBackFunction         : BTI_CB_FUNC_PTR_T;
               fPreviousCallBackFunction : BTI_CB_FUNC_PTR_PTR_T;
           VAR bUserData;
           VAR bPreviousUserData         : POINTER ) : INTEGER;
							 external 'W1SQLV7' name 'XQLCALLBACK';

   FUNCTION xShareSessionID(
               VAR tChangeCount : INTEGER ) : INTEGER;
               external 'W1SQLV7' name 'XSHARESESSIONID';

   FUNCTION SQLGetCountDatabaseNames(
              VAR tCount : INTEGER ) : INTEGER;
              external 'W1DBNV7' name 'SQLGETCOUNTDATABASENAMES';

   FUNCTION SQLGetCountRemoteDatabaseNames(
              VAR tCount : INTEGER ) : INTEGER;
              external 'W1DBNV7' name 'SQLGETCOUNTREMOTEDATABASENAMES';

   FUNCTION SQLGetDatabaseNames(
              VAR tBufLen  : INTEGER;
              VAR bDataBuf  ) : INTEGER;
              external 'W1DBNV7' name 'SQLGETDATABASENAMES';

   FUNCTION SQLGetRemoteDatabaseNames(
              VAR tBufLen  : INTEGER;
              VAR bDataBuf ) : INTEGER;
              external 'W1DBNV7' name 'SQLGETREMOTEDATABASENAMES';

   FUNCTION SQLUnloadDBNAMES(
              iReserved : INTEGER ) : INTEGER;
              external 'W1DBNV7' name 'SQLUNLOADDBNAMES';

{***********************************************************************
   SQL-LEVEL FUNCTIONS
***********************************************************************}
   FUNCTION XQLCursor(
               VAR iCursorID : INTEGER ) : INTEGER;
							 external 'W1SQLV7' name 'XQLCURSOR';

   FUNCTION XQLCompile(
               iCursorID     : INTEGER;
           VAR tStatementLen : INTEGER;
           VAR sStatement )  : INTEGER;
           external 'W1SQLV7' name 'XQLCOMPILE';

   FUNCTION XQLDescribe(
               iCursorID   : INTEGER;
               tPosition   : INTEGER;
           VAR iDataType   : INTEGER;
           VAR tSize       : INTEGER;
           VAR tDecPlaces  : INTEGER;
           VAR tDisplayLen : INTEGER;
           VAR tNameLen    : INTEGER;
           VAR sName     ) : INTEGER;
           external 'W1SQLV7' name 'XQLDESCRIBE';

    FUNCTION XQLExec(
                iCursorID : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XQLEXEC';

   FUNCTION XQLFetch(
               iCursorID  : INTEGER;
               iOption    : INTEGER;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf;
           VAR lCount     : LONGINT;
               iASCIIFlag : INTEGER;
               iSpacing   : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XQLFETCH';

	 FUNCTION XQLFormat(
               iCursorID : INTEGER;
               tPosition : INTEGER;
               tMaskLen  : INTEGER;
           VAR sMask   ) : INTEGER;
           external 'W1SQLV7' name 'XQLFORMAT';

   FUNCTION XQLFree(
               iCursorID : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XQLFREE';

   FUNCTION XQLLogin(
               VAR sUser;
               VAR sPassword;
               VAR sDDPath;
               VAR sDataPath;
               VAR sReserved;
                   iFeaturesUsed : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XQLLOGIN';

   FUNCTION XQLLogout : INTEGER;
           external 'W1SQLV7' name 'XQLLOGOUT';

   FUNCTION XQLSPUtility(
               iCursorID       : INTEGER;
               iOption         : INTEGER;
           VAR tStatementCount : INTEGER;
           VAR tStatementExec  : INTEGER;
           VAR tBufLen         : INTEGER;
           VAR bDataBuf )      : INTEGER;
           external 'W1SQLV7' name 'XQLSPUTILITY';

   FUNCTION XQLStatus(
							 iCursor : INTEGER;
               iOption : INTEGER;
           VAR sStatBuf ) : INTEGER;
           external 'W1SQLV7' name 'XQLSTATUS';

   FUNCTION XQLStop : INTEGER;
            external 'W1SQLV7' name 'XQLSTOP';

   FUNCTION XQLSubst(
               iCursorID : INTEGER;
               tCount    : INTEGER;
               tNameLen  : INTEGER;
           VAR sVarNames;
               tTextLen  : INTEGER;
           VAR sValueText ) : INTEGER;
            external 'W1SQLV7' name 'XQLSUBST';

   FUNCTION XQLVersion(
               VAR sVersion ) : INTEGER;
            external 'W1SQLV7' name 'XQLVERSION';

   FUNCTION XQLConvert(
               iOption  : INTEGER;
               iType    : INTEGER;
               tSize    : INTEGER;
               tDec     : INTEGER;
               tdSize   : INTEGER;
           VAR sValue;
           VAR sRetVal;
           VAR sMask;
               sJustify : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XQLCONVERT';

	 FUNCTION XQLValidate(
               VAR tCount     : INTEGER;
               VAR sFieldName;
                   tBufLen    : INTEGER;
               VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XQLVALIDATE';

   FUNCTION XQLMask(
               iOption : INTEGER;
               iType   : INTEGER;
               tSize   : INTEGER;
               tDec    : INTEGER;
           VAR tLen    : INTEGER;
           VAR sMask ) : INTEGER;
           external 'W1SQLV7' name 'XQLMASK';

{***********************************************************************
   HISTORICAL RELATIONAL PRIMITIVES
***********************************************************************}
   FUNCTION xCompute(
               iCursorID  : INTEGER;
           VAR sFldName;
               iFldType   : INTEGER;
               tFldLen    : INTEGER;
               tDecPlaces : INTEGER;
           VAR tExpLen    : INTEGER;
           VAR sExpression ) : INTEGER;
           external 'W1SQLV7' name 'XCOMPUTE';

   FUNCTION xDescribe(
               iCursorID  : INTEGER;
               iOption    : INTEGER;
           VAR tBufLen    : INTEGER;
							 tPosition  : INTEGER;
           VAR tCount     : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDESCRIBE';

   FUNCTION xMovefld(
               iCursorID     : INTEGER;
               tFromPosition : INTEGER;
               tToPosition   : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XMOVEFLD';

   FUNCTION xFetch(
               iCursorID    : INTEGER;
           VAR tBufLen      : INTEGER;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
           VAR lRejectCount : LONGINT;
           VAR bDataBuf  )  : INTEGER;
           external 'W1SQLV7' name 'XFETCH';

   FUNCTION xField(
               iCursorID   : INTEGER;
               iOption     : INTEGER;
               tPosition   : INTEGER;
           VAR tCount      : INTEGER;
           VAR sFldNames ) : INTEGER;
           external 'W1SQLV7' name 'XFIELD';

   FUNCTION xFree(
               iCursorID : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XFREE';

   FUNCTION xInsert(
							 iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT;
           VAR bDataBuf )   : INTEGER;
           external 'W1SQLV7' name 'XINSERT';

   FUNCTION xJoin(
               iCursorID    : INTEGER;
           VAR sSecFile;
           VAR sOwner;
               iOption      : INTEGER;
               tPriFldCount : INTEGER;
           VAR sPriFlds;
               tSecFldCount : INTEGER;
           VAR sSecFlds )   : INTEGER;
           external 'W1SQLV7' name 'XJOIN';

   FUNCTION xLogin(
           VAR sUser;
           VAR sPassword;
           VAR sDDPath;
           VAR sDataPath;
           VAR sReserved;
               iFeaturesUsed : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XLOGIN';

   FUNCTION xLogout : INTEGER;
           external 'W1SQLV7' name 'XLOGOUT';

   FUNCTION xNew(
           VAR iCursorID : INTEGER;
           VAR sFileName;
					 VAR sOwner;
               iOpenMode : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XNEW';

   FUNCTION xOrder(
               iCursorID : INTEGER;
               tCount    : INTEGER;
           VAR sOrder )  : INTEGER;
           external 'W1SQLV7' name 'XORDER';

   FUNCTION xRemall(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
               lRejectCount : LONGINT ) : INTEGER;
           external 'W1SQLV7' name 'XREMALL';

   FUNCTION xRemove(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT ) : INTEGER;
           external 'W1SQLV7' name 'XREMOVE';

   FUNCTION xReset(
           VAR sReserved ) : INTEGER;
           external 'W1SQLV7' name 'XRESET';

   FUNCTION xRestrict(
               iCursorID : INTEGER;
               iOption   : INTEGER;
					 VAR tExpLen   : INTEGER;
           VAR sExpression ) : INTEGER;
           external 'W1SQLV7' name 'XRESTRICT';

   FUNCTION xStop : INTEGER;
           external 'W1SQLV7' name 'XSTOP';

   FUNCTION xTrans(
               iOption : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XTRANS';

   FUNCTION xStore(
               iCursorID : INTEGER;
           VAR sViewName;
               tTextLen  : INTEGER;
           VAR sText )   : INTEGER;
           external 'W1SQLV7' name 'XSTORE';

   FUNCTION xRecall(
           VAR iCursorID   : INTEGER;
           VAR sViewName;
               tOwnerCount : INTEGER;
           VAR sOwner;
               iOpenMode   : INTEGER;
           VAR tTextLen    : INTEGER;
           VAR sText )     : INTEGER;
           external 'W1SQLV7' name 'XRECALL';

   FUNCTION xUpdate(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
           VAR lRecordCount : LONGINT;
					 VAR bDataBuf )   : INTEGER;
           external 'W1SQLV7' name 'XUPDATE';

   FUNCTION xUpdall(
               iCursorID    : INTEGER;
           VAR tFileCount   : INTEGER;
           VAR sFileNames;
               iOption      : INTEGER;
           VAR lRecordCount : LONGINT;
           VAR lRejectCount : LONGINT;
               tFldCount    : INTEGER;
           VAR sUpdateFld;
           VAR sReplaceFld ) : INTEGER;
           external 'W1SQLV7' name 'XUPDALL';

   FUNCTION xDD(
           VAR sPathName;
               iOption : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XDD';

   FUNCTION xDDAttr(
                iOption    : INTEGER;
            VAR sFldName;
                iAttrType  : INTEGER;
            VAR tBufLen    : INTEGER;
            VAR sAttrBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDATTR';

   FUNCTION xDDModify(
               iOption     : INTEGER;
           VAR sFileName;
               iCreate    : INTEGER;
           VAR sPathName;
					 VAR sOwner;
               iOwnerFlag : INTEGER;
               tFldCount  : INTEGER;
           VAR bFldBuf;
               tIndxCount : INTEGER;
           VAR bIndxBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDMODIFY';

   FUNCTION xDDCreate(
               iOption           : INTEGER;
           VAR sFileName;
               iCreate           : INTEGER;
           VAR sPathName;
           VAR sOwner;
               iOwnerFlag        : INTEGER;
               tFldCount         : INTEGER;
           VAR bFldBuf;
               tIndxCount        : INTEGER;
           VAR bIndxBuf;
               tBufLen           : INTEGER;
           VAR bCreateParmsBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDCREATE';

   FUNCTION xDDDrop(
           VAR sName;
               iType   : INTEGER;
               iDelete : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XDDDROP';

    FUNCTION xDDField(
                iOption    : INTEGER;
            VAR tCount     : INTEGER;
            VAR sFldNames;
						VAR tBufLen    : INTEGER;
            VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDFIELD';

   FUNCTION xDDFile(
               iOption    : INTEGER;
           VAR tCount     : INTEGER;
           VAR sFileNames;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDFILE';

   FUNCTION xDDIndex(
               iOption    : INTEGER;
           VAR tCount     : INTEGER;
           VAR sIndexName;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDINDEX';

   FUNCTION xDDPath(
               iOption     : INTEGER;
           VAR sPathName ) : INTEGER;
           external 'W1SQLV7' name 'XDDPATH';

   FUNCTION xDDView(
           VAR tCount     : INTEGER;
           VAR sViewName;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XDDVIEW';

   FUNCTION xAccess(
					 VAR sMstrPswd;
           VAR sUser;
               iOption    : INTEGER;
               iAccRights : INTEGER;
           VAR sFileName;
           VAR tCount     : INTEGER;
           VAR sFldNames;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XACCESS';

	 FUNCTION xPassword(
           VAR sUser;
           VAR sPassword ) : INTEGER;
           external 'W1SQLV7' name 'XPASSWORD';

   FUNCTION xSecurity(
           VAR sMstrPswd;
               iOption : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XSECURITY';

   FUNCTION xUser(
           VAR sMstPswd;
               iOption    : INTEGER;
           VAR sUser;
           VAR sPassword;
               iFlags     : INTEGER;
           VAR tCount     : INTEGER;
           VAR tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
           external 'W1SQLV7' name 'XUSER';

   FUNCTION xChar(
							 iOption : INTEGER;
               iType   : INTEGER;
           VAR cCharacter ) : INTEGER;
           external 'W1SQLV7' name 'XCHAR';

   FUNCTION xVersion(
           VAR sVersion ) : INTEGER;
           external 'W1SQLV7' name 'XVERSION';

   FUNCTION xStatus(
               iCursorID  : INTEGER;
							 iOption    : INTEGER;
           VAR tLen       : INTEGER;
           VAR sStatBuf ) : INTEGER;
           external 'W1SQLV7' name 'XSTATUS';

   FUNCTION xConvert(
               iOption  : INTEGER;
               iType    : INTEGER;
               tSize    : INTEGER;
               tDec     : INTEGER;
               tDSize   : INTEGER;
           VAR sValue;
           VAR sRetVal;
           VAR sMask;
               iJustify : INTEGER ) : INTEGER;
           external 'W1SQLV7' name 'XCONVERT';

   FUNCTION xValidate(
           VAR tCount     : INTEGER;
           VAR sFieldName;
               tBufLen    : INTEGER;
           VAR bDataBuf ) : INTEGER;
					 external 'W1SQLV7' name 'XVALIDATE';

   FUNCTION xMask(
               iOption : INTEGER;
               iType   : INTEGER;
               tSize   : INTEGER;
               iDec    : INTEGER;
           VAR tLen    : INTEGER;
           VAR sMask ) : INTEGER;
           external 'W1SQLV7' name 'XMASK';

END.
